// JavaScript Browser Sniffer
// Eric Krok, Andy King, Michel Plungjan Jan. 31, 2002
// see http://www.webreference.com/ for more information
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
// please send any improvements to aking@internet.com and we'll
// roll the best ones in
//
// adapted from Netscape's Ultimate client-side JavaScript client sniffer
// and andy king's sniffer
// Revised May 7 99 to add is.nav5up and is.ie5up (see below). (see below).
// Revised June 11 99 to add additional props, checks
// Revised June 23 99 added screen props - gecko m6 doesn't support yet - abk
//                    converted to var is_ from is object to work everywhere
// 990624 - added cookie forms links frames checks - abk
// 001031 - ie4 mod 5.0 - 5. (ie5.5 mididentified - abk)
//          is_ie4 mod tp work with ie6+ - abk
// 001120 - ns6 released, document.layers false, put back in
//        - is_nav6 test added - abk
// 001121 - ns6+ added, used document.getElementById, better test, dom-compl
// 010117 - actual version for ie3-5.5 by Michel Plungjan
// 010118 - actual version for ns6 by Michel Plungjan
// 010217 - netscape 6/mz 6 ie5.5 onload defer bug docs - abk
// 011107 - added is_ie6 and is_ie6up variables - dmr
// 020128 - added link to netscape's sniffer, on which this is based - abk
//          updated sniffer for aol4-6, ie5mac = js1.4, TVNavigator, AOLTV,
//          hotjava
// 020131 - cleaned up links, added more links to example object detection
// 020131 - a couple small problems with Opera detection. First, when Opera
//          is set to be compatible with other browsers it will contain their
//          information in the userAgent strings. Thus, to be sure we have 
//          Opera we should check for it before checking for the other bigs.
//          (And make sure the others are !opera.) Also corrected a minor
//          bug in the is_opera6up assignment.
// 020214 - Added link for Opera/JS compatibility; added improvements for 
//          windows xp/2000 id in opera and aol 7 id (thanks to Les
//          Hill, Les.Hill@getronics.com, for the suggestion).
// 020531 - Added N6/7 and moz identifiers. 
// 020605 - Added mozilla guessing, Netscape 7 identification, and cleaner
//          identification for Netscape 6. (this comment added after code 
//          changes)
// 020725 - Added is_gecko. dmr
// 021205 - Added is_Flash and is_FlashVersion, based on Doc JavaScript code. 
//          Added Opera 7 variables. dmr
// 021209 - Added aol8. dmr
// 030110 - Added is_safari, added 1.5 js designation for Opera 7. dmr
// 030128 - Added is_konq, per user suggestion (thanks to Sam Vilain).
//          Removed duplicate Opera checks left over after last revision.  dmr
//
// Everything you always wanted to know about your JavaScript client
// but were afraid to ask. Creates "is_" variables indicating:
// (1) browser vendor:
//     is_nav, is_ie, is_opera
// (2) browser version number:
//     is_major (integer indicating major version number: 2, 3, 4 ...)
//     is_minor (float   indicating full  version number: 2.02, 3.01, 4.04 ...)
// (3) browser vendor AND major version number
//     is_nav2, is_nav3, is_nav4, is_nav4up, is_nav5, is_nav5up, 
//     is_nav6, is_nav6up, is_ie3, is_ie4, is_ie4up, is_ie5up, is_ie6...
// (4) JavaScript version number:
//     is_js (float indicating full JavaScript version number: 1, 1.1, 1.2 ...)
// (5) OS platform and version:
//     is_win, is_win16, is_win32, is_win31, is_win95, is_winnt, is_win98
//     is_os2
//     is_mac, is_mac68k, is_macppc
//     is_unix
//        is_sun, is_sun4, is_sun5, is_suni86
//        is_irix, is_irix5, is_irix6
//        is_hpux, is_hpux9, is_hpux10
//        is_aix, is_aix1, is_aix2, is_aix3, is_aix4
//        is_linux, is_sco, is_unixware, is_mpras, is_reliant
//        is_dec, is_sinix, is_freebsd, is_bsd
//     is_vms
//
// based in part on 
// http://www.mozilla.org/docs/web-developer/sniffer/browser_type.html
// The Ultimate JavaScript Client Sniffer
// and Andy King's object detection sniffer
//
// Note: you don't want your Nav4 or IE4 code to "turn off" or
// stop working when Nav5 and IE5 (or later) are released, so
// in conditional code forks, use is_nav4up ("Nav4 or greater")
// and is_ie4up ("IE4 or greater") instead of is_nav4 or is_ie4
// to check version in code which you want to work on future
// versions. For DOM tests scripters commonly used the 
// is_getElementById test, but make sure you test your code as
// filter non-compliant browsers (Opera 5-6 for example) as some 
// browsers return true for this test, and don't fully support
// the W3C's DOM1.
//
// Objekte
function browserType(){
  this.is_minor=0;
  this.is_major=0;
  this.is_AOLTV=false;
  this.is_Flash=false;
  this.is_FlashVersion=false;
  this.is_TVNavigator=false;
  this.is_aix=false;
  this.is_aix1=false;
  this.is_aix2=false;
  this.is_aix3=false;
  this.is_aix4=false;
  this.is_all=false;
  this.is_anchors=false;
  this.is_aol=false;
  this.is_aol3=false;
  this.is_aol4=false;
  this.is_aol5=false;
  this.is_aol6=false;
  this.is_aol7=false;
  this.is_aol8=false;
  this.is_bsd=false;
  this.is_cookie=false;
  this.is_dec=false;
  this.is_documentElement=false;
  this.is_forms=false;
  this.is_frames=false;
  this.is_freebsd=false;
  this.is_gecko=false;
  this.is_getElementById=false;
  this.is_getElementsByTagName=false;
  this.is_gver=false;
  this.is_hotjava=false;
  this.is_hotjava3=false;
  this.is_hotjava3up=false;
  this.is_hpux=false;
  this.is_hpux9=false;
  this.is_ie=false;
  this.is_ie3=false;
  this.is_ie4=false;
  this.is_ie4up=false;
  this.is_ie5=false;
  this.is_ie5_5=false;
  this.is_ie5_5up=false;
  this.is_ie5up=false;
  this.is_ie6=false;
  this.is_ie6up=false;
  this.is_images=false;
  this.is_irix=false;
  this.is_irix5=false;
  this.is_irix6=false;
  this.is_java=false;
  this.is_js=false;
  this.is_khtml=false;
  this.is_konq=false;
  this.is_layers=false;
  this.is_links=false;
  this.is_linux=false;
  this.is_mac=false;
  this.is_mac68k=false;
  this.is_macppc=false;
  this.is_moz=false;
  this.is_moz_ver=false;
  this.is_mpras=false;
  this.is_nav=false;
  this.is_nav2=false;
  this.is_nav3=false;
  this.is_nav4=false;
  this.is_nav4up=false;
  this.is_nav5=false;
  this.is_nav5up=false;
  this.is_nav6=false;
  this.is_nav6up=false;
  this.is_nav7=false;
  this.is_nav7up=false;
  this.is_navonly=false;
  this.is_opera=false;
  this.is_opera2=false;
  this.is_opera3=false;
  this.is_opera4=false;
  this.is_opera5=false;
  this.is_opera5up=false;
  this.is_opera6=false;
  this.is_opera6up=false;
  this.is_opera7=false;
  this.is_opera7up=false;
  this.is_option=false;
  this.is_os2=false;
  this.is_paren=false;
  this.is_regexp=false;
  this.is_reliant=false;
  this.is_safari=false;
  this.is_sco=false;
  this.is_screen=false;
  this.is_sinix=false;
  this.is_sun=false;
  this.is_sun4=false;
  this.is_sun5=false;
  this.is_suni86=false;
  this.is_unix=false;
  this.is_unixware=false;
  this.is_vms=false;
  this.is_webtv=false;
  this.is_win=false;
  this.is_win16=false;
  this.is_win2k=false;
  this.is_win31=false;
  this.is_win32=false;
  this.is_win95=false;
  this.is_win98=false;
  this.is_winme=false;
  this.is_winnt=false;
  this.is_winxp=false;
}
function sniffBrowser(){
  // convert all characters to lowercase to simplify testing
  var bt = new browserType();
  var agt=navigator.userAgent.toLowerCase();
  var appVer = navigator.appVersion.toLowerCase();
  // *** BROWSER VERSION ***
  bt.is_minor = parseFloat(appVer);
  bt.is_major = parseInt(bt.is_minor);
  bt.is_opera = (agt.indexOf("opera") != -1);
  bt.is_opera2 = (agt.indexOf("opera 2") != -1 || agt.indexOf("opera/2") != -1);
  bt.is_opera3 = (agt.indexOf("opera 3") != -1 || agt.indexOf("opera/3") != -1);
  bt.is_opera4 = (agt.indexOf("opera 4") != -1 || agt.indexOf("opera/4") != -1);
  bt.is_opera5 = (agt.indexOf("opera 5") != -1 || agt.indexOf("opera/5") != -1);
  bt.is_opera6 = (agt.indexOf("opera 6") != -1 || agt.indexOf("opera/6") != -1); // new 020128- abk
  bt.is_opera7 = (agt.indexOf("opera 7") != -1 || agt.indexOf("opera/7") != -1); // new 021205- dmr
  bt.is_opera5up = (bt.is_opera && (!bt.is_opera2) && !bt.is_opera3 && !bt.is_opera4);
  bt.is_opera6up = (bt.is_opera && !bt.is_opera2 && !bt.is_opera3 && !bt.is_opera4 && !bt.is_opera5); // new020128
  bt.is_opera7up = (bt.is_opera && !bt.is_opera2 && !bt.is_opera3 && !bt.is_opera4 && !bt.is_opera5 && !bt.is_opera6); // new021205 dmr
  // Note: On IE, start of appVersion return 3 or 4
  // which supposedly is the version of Netscape it is compatible with.
  // So we look for the real version further on in the string
  var iePos  = appVer.indexOf('msie');
  if (iePos !=-1) {
    bt.is_minor = parseFloat(appVer.substring(iePos+5,appVer.indexOf(';',iePos)))
      bt.is_major = parseInt(bt.is_minor);
  }
  // ditto Konqueror
                                      
  bt.is_konq = false;
  var kqPos   = agt.indexOf('konqueror');
  if (kqPos !=-1) {                 
    bt.is_konq  = true;
    bt.is_minor = parseFloat(agt.substring(kqPos+10,agt.indexOf(';',kqPos)));
    bt.is_major = parseInt(bt.is_minor);
  }                                 
  bt.is_getElementById   = (document.getElementById) ? "true" : "false"; // 001121-abk
  bt.is_getElementsByTagName = (document.getElementsByTagName) ? "true" : "false"; // 001127-abk
  bt.is_documentElement = (document.documentElement) ? "true" : "false"; // 001121-abk
  bt.is_safari = ((agt.indexOf('safari')!=-1)&&(agt.indexOf('mac')!=-1))?true:false;
  bt.is_khtml  = (bt.is_safari || bt.is_konq);
  bt.is_gecko = ((!bt.is_khtml)&&(navigator.product)&&(navigator.product.toLowerCase()=="gecko"))?true:false;
  bt.is_gver  = 0;
  if (bt.is_gecko) bt.is_gver=navigator.productSub;
  bt.is_moz   = ((agt.indexOf('mozilla/5')!=-1) && (agt.indexOf('spoofer')==-1) &&
                 (agt.indexOf('compatible')==-1) && (agt.indexOf('opera')==-1)  &&
                 (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1)     &&
                 (bt.is_gecko) && 
                 ((navigator.vendor=="")||(navigator.vendor=="Mozilla")));
  if (bt.is_moz) {
    bt.is_moz_ver = (navigator.vendorSub)?navigator.vendorSub:0;
    if(!(bt.is_moz_ver)) {
      bt.is_moz_ver = agt.indexOf('rv:');
      bt.is_moz_ver = agt.substring(bt.is_moz_ver+3);
      bt.is_paren   = bt.is_moz_ver.indexOf(')');
      bt.is_moz_ver = bt.is_moz_ver.substring(0,bt.is_paren);
    }
    bt.is_minor = bt.is_moz_ver;
    bt.is_major = parseInt(bt.is_moz_ver);
  }
  bt.is_nav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1)
                && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1)
                && (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1)
                && (!bt.is_khtml) && (!(bt.is_moz)));
  // Netscape6 is mozilla/5 + Netscape6/6.0!!!
  // Mozilla/5.0 (Windows; U; Win98; en-US; m18) Gecko/20001108 Netscape6/6.0
  // Changed this to use navigator.vendor/vendorSub - dmr 060502   
  // var nav6Pos = agt.indexOf('netscape6');
  // if (nav6Pos !=-1) {
  if ((navigator.vendor)&&
      ((navigator.vendor=="Netscape6")||(navigator.vendor=="Netscape"))&&
      (bt.is_nav)) {
    bt.is_major = parseInt(navigator.vendorSub);
    // here we need bt.is_minor as a valid float for testing. We'll
    // revert to the actual content before printing the result. 
    bt.is_minor = parseFloat(navigator.vendorSub);
  }
  bt.is_nav2 = (bt.is_nav && (bt.is_major == 2));
  bt.is_nav3 = (bt.is_nav && (bt.is_major == 3));
  bt.is_nav4 = (bt.is_nav && (bt.is_major == 4));
  bt.is_nav4up = (bt.is_nav && bt.is_minor >= 4);  // changed to bt.is_minor for
  // consistency - dmr, 011001
  bt.is_navonly      = (bt.is_nav && ((agt.indexOf(";nav") != -1) ||
                                      (agt.indexOf("; nav") != -1)) );
  bt.is_nav6   = (bt.is_nav && bt.is_major==6);    // new 010118 mhp
  bt.is_nav6up = (bt.is_nav && bt.is_minor >= 6) // new 010118 mhp
    bt.is_nav5   = (bt.is_nav && bt.is_major == 5 && !bt.is_nav6); // checked for ns6
  bt.is_nav5up = (bt.is_nav && bt.is_minor >= 5);
  bt.is_nav7   = (bt.is_nav && bt.is_major == 7);
  bt.is_nav7up = (bt.is_nav && bt.is_minor >= 7);
  bt.is_ie   = ((iePos!=-1) && (!bt.is_opera) && (!bt.is_khtml));
  bt.is_ie3  = (bt.is_ie && (bt.is_major < 4));
  bt.is_ie4   = (bt.is_ie && bt.is_major == 4);
  bt.is_ie4up = (bt.is_ie && bt.is_minor >= 4);
  bt.is_ie5   = (bt.is_ie && bt.is_major == 5);
  bt.is_ie5up = (bt.is_ie && bt.is_minor >= 5);
    
  bt.is_ie5_5  = (bt.is_ie && (agt.indexOf("msie 5.5") !=-1)); // 020128 new - abk
  bt.is_ie5_5up =(bt.is_ie && bt.is_minor >= 5.5);                // 020128 new - abk
        
  bt.is_ie6   = (bt.is_ie && bt.is_major == 6);
  bt.is_ie6up = (bt.is_ie && bt.is_minor >= 6);
  // KNOWN BUG: On AOL4, returns false if IE3 is embedded browser
  // or if this is the first browser window opened.  Thus the
  // variables bt.is_aol, bt.is_aol3, and bt.is_aol4 aren't 100% reliable.
  bt.is_aol   = (agt.indexOf("aol") != -1);
  bt.is_aol3  = (bt.is_aol && bt.is_ie3);
  bt.is_aol4  = (bt.is_aol && bt.is_ie4);
  bt.is_aol5  = (agt.indexOf("aol 5") != -1);
  bt.is_aol6  = (agt.indexOf("aol 6") != -1);
  bt.is_aol7  = ((agt.indexOf("aol 7")!=-1) || (agt.indexOf("aol7")!=-1));
  bt.is_aol8  = ((agt.indexOf("aol 8")!=-1) || (agt.indexOf("aol8")!=-1));
  bt.is_webtv = (agt.indexOf("webtv") != -1);
    
  // new 020128 - abk
    
  bt.is_TVNavigator = ((agt.indexOf("navio") != -1) || (agt.indexOf("navio_aoltv") != -1)); 
  bt.is_AOLTV = bt.is_TVNavigator;
  bt.is_hotjava = (agt.indexOf("hotjava") != -1);
  bt.is_hotjava3 = (bt.is_hotjava && (bt.is_major == 3));
  bt.is_hotjava3up = (bt.is_hotjava && (bt.is_major >= 3));
  // end new
        
  // *** JAVASCRIPT VERSION CHECK ***
  // Useful to workaround Nav3 bug in which Nav3
  // loads <SCRIPT LANGUAGE="JavaScript1.2">.
  // updated 020131 by dragle
  bt.is_js;
  if (bt.is_nav2 || bt.is_ie3) bt.is_js = 1.0;
  else if (bt.is_nav3) bt.is_js = 1.1;
  else if ((bt.is_opera5)||(bt.is_opera6)) bt.is_js = 1.3; // 020214 - dmr
  else if (bt.is_opera7up) bt.is_js = 1.5; // 031010 - dmr
  else if (bt.is_khtml) bt.is_js = 1.5;   // 030110 - dmr
  else if (bt.is_opera) bt.is_js = 1.1;
  else if ((bt.is_nav4 && (bt.is_minor <= 4.05)) || bt.is_ie4) bt.is_js = 1.2;
  else if ((bt.is_nav4 && (bt.is_minor > 4.05)) || bt.is_ie5) bt.is_js = 1.3;
  else if (bt.is_nav5 && !(bt.is_nav6)) bt.is_js = 1.4;
  else if (bt.is_hotjava3up) bt.is_js = 1.4; // new 020128 - abk
  else if (bt.is_nav6up) bt.is_js = 1.5;
  // NOTE: In the future, update this code when newer versions of JS
  // are released. For now, we try to provide some upward compatibility
  // so that future versions of Nav and IE will show they are at
  // *least* JS 1.x capable. Always check for JS version compatibility
  // with > or >=.
  else if (bt.is_nav && (bt.is_major > 5)) bt.is_js = 1.4;
  else if (bt.is_ie && (bt.is_major > 5)) bt.is_js = 1.3;
  else if (bt.is_moz) bt.is_js = 1.5;
    
  // what about ie6 and ie6up for js version? abk
    
  // HACK: no idea for other browsers; always check for JS version 
  // with > or >=
  else bt.is_js = 0.0;
  // HACK FOR IE5 MAC = js vers = 1.4 (if put inside if/else jumps out at 1.3)
  if ((agt.indexOf("mac")!=-1) && bt.is_ie5up) bt.is_js = 1.4; // 020128 - abk
    
  // Done with bt.is_minor testing; revert to real for N6/7
  if (bt.is_nav6up) {
    bt.is_minor = navigator.vendorSub;
  }
  // *** PLATFORM ***
  bt.is_win   = ( (agt.indexOf("win")!=-1) || (agt.indexOf("16bit")!=-1) );
  // NOTE: On Opera 3.0, the userAgent string includes "Windows 95/NT4" on all
  //        Win32, so you can't distinguish between Win95 and WinNT.
  bt.is_win95 = ((agt.indexOf("win95")!=-1) || (agt.indexOf("windows 95")!=-1));
  // is this a 16 bit compiled version?
  bt.is_win16 = ((agt.indexOf("win16")!=-1) ||
                 (agt.indexOf("16bit")!=-1) || (agt.indexOf("windows 3.1")!=-1) ||
                 (agt.indexOf("windows 16-bit")!=-1) );
  bt.is_win31 = ((agt.indexOf("windows 3.1")!=-1) || (agt.indexOf("win16")!=-1) ||
                 (agt.indexOf("windows 16-bit")!=-1));
        
  bt.is_winme = ((agt.indexOf("win 9x 4.90")!=-1));    // new 020128 - abk
bt.is_win2k = ((agt.indexOf("windows nt 5.0")!=-1) || (agt.indexOf("windows 2000")!=-1)); // 020214 - dmr
  bt.is_winxp = ((agt.indexOf("windows nt 5.1")!=-1) || (agt.indexOf("windows xp")!=-1)); // 020214 - dmr
  // NOTE: Reliable detection of Win98 may not be possible. It appears that:
  //       - On Nav 4.x and before you'll get plain "Windows" in userAgent.
  //       - On Mercury client, the 32-bit version will return "Win98", but
  //         the 16-bit version running on Win98 will still return "Win95".
  bt.is_win98 = ((agt.indexOf("win98")!=-1) || (agt.indexOf("windows 98")!=-1));
  bt.is_winnt = ((agt.indexOf("winnt")!=-1) || (agt.indexOf("windows nt")!=-1));
  bt.is_win32 = (bt.is_win95 || bt.is_winnt || bt.is_win98 ||
                 ((bt.is_major >= 4) && (navigator.platform == "Win32")) ||
                 (agt.indexOf("win32")!=-1) || (agt.indexOf("32bit")!=-1));
  bt.is_os2   = ((agt.indexOf("os/2")!=-1) ||
                 (navigator.appVersion.indexOf("OS/2")!=-1) ||
                 (agt.indexOf("ibm-webexplorer")!=-1));
  bt.is_mac    = (agt.indexOf("mac")!=-1);
  if (bt.is_mac) { bt.is_win = !bt.is_mac; } // dmr - 06/20/2002
  bt.is_mac68k = (bt.is_mac && ((agt.indexOf("68k")!=-1) ||
                                (agt.indexOf("68000")!=-1)));
  bt.is_macppc = (bt.is_mac && ((agt.indexOf("ppc")!=-1) ||
                                (agt.indexOf("powerpc")!=-1)));
  bt.is_sun   = (agt.indexOf("sunos")!=-1);
  bt.is_sun4  = (agt.indexOf("sunos 4")!=-1);
  bt.is_sun5  = (agt.indexOf("sunos 5")!=-1);
  bt.is_suni86= (bt.is_sun && (agt.indexOf("i86")!=-1));
  bt.is_irix  = (agt.indexOf("irix") !=-1);    // SGI
  bt.is_irix5 = (agt.indexOf("irix 5") !=-1);
  bt.is_irix6 = ((agt.indexOf("irix 6") !=-1) || (agt.indexOf("irix6") !=-1));
  bt.is_hpux  = (agt.indexOf("hp-ux")!=-1);
  bt.is_hpux9 = (bt.is_hpux && (agt.indexOf("09.")!=-1));
  bt.is_hpux10= (bt.is_hpux && (agt.indexOf("10.")!=-1));
  bt.is_aix   = (agt.indexOf("aix") !=-1);      // IBM
  bt.is_aix1  = (agt.indexOf("aix 1") !=-1);
  bt.is_aix2  = (agt.indexOf("aix 2") !=-1);
  bt.is_aix3  = (agt.indexOf("aix 3") !=-1);
  bt.is_aix4  = (agt.indexOf("aix 4") !=-1);
  bt.is_linux = (agt.indexOf("inux")!=-1);
  bt.is_sco   = (agt.indexOf("sco")!=-1) || (agt.indexOf("unix_sv")!=-1);
  bt.is_unixware = (agt.indexOf("unix_system_v")!=-1);
  bt.is_mpras    = (agt.indexOf("ncr")!=-1);
  bt.is_reliant  = (agt.indexOf("reliantunix")!=-1);
  bt.is_dec   = ((agt.indexOf("dec")!=-1) || (agt.indexOf("osf1")!=-1) ||
                 (agt.indexOf("dec_alpha")!=-1) || (agt.indexOf("alphaserver")!=-1) ||
                 (agt.indexOf("ultrix")!=-1) || (agt.indexOf("alphastation")!=-1));
  bt.is_sinix = (agt.indexOf("sinix")!=-1);
  bt.is_freebsd = (agt.indexOf("freebsd")!=-1);
  bt.is_bsd = (agt.indexOf("bsd")!=-1);
  bt.is_unix  = ((agt.indexOf("x11")!=-1) || bt.is_sun || bt.is_irix || bt.is_hpux ||
                 bt.is_sco ||bt.is_unixware || bt.is_mpras || bt.is_reliant ||
                 bt.is_dec || bt.is_sinix || bt.is_aix || bt.is_linux || bt.is_bsd || bt.is_freebsd);
  bt.is_vms   = ((agt.indexOf("vax")!=-1) || (agt.indexOf("openvms")!=-1));
  // additional checks, abk
  bt.is_anchors = (document.anchors) ? "true":"false";
  bt.is_regexp = (window.RegExp) ? "true":"false";
  bt.is_option = (window.Option) ? "true":"false";
  bt.is_all = (document.all) ? "true":"false";
  // cookies - 990624 - abk
  //        document.cookie = "cookies=true";
  //        bt.is_cookie = (document.cookie) ? "true" : "false";
  bt.is_images = (document.images) ? "true":"false";
bt.is_layers = (document.layers) ? "true":"false"; // gecko m7 bug?
  // new doc obj tests 990624-abk
  bt.is_forms = (document.forms) ? "true" : "false";
  bt.is_links = (document.links) ? "true" : "false";
  bt.is_frames = (window.frames) ? "true" : "false";
  bt.is_screen = (window.screen) ? "true" : "false";
  // java
  bt.is_java = (navigator.javaEnabled());
  // Flash checking code adapted from Doc JavaScript information; 
  // see http://webref.com/js/column84/2.html
  bt.is_Flash        = false;
  bt.is_FlashVersion = 0;
  if ((bt.is_nav||bt.is_opera||bt.is_moz)||
      (bt.is_mac && bt.is_ie5up)) {
    var plugin = (navigator.mimeTypes && 
                  navigator.mimeTypes["application/x-shockwave-flash"] &&
                  navigator.mimeTypes["application/x-shockwave-flash"].enabledPlugin) ?
      navigator.mimeTypes["application/x-shockwave-flash"].enabledPlugin : 0;
    if (plugin) {
      bt.is_Flash = true;
      bt.is_FlashVersion = parseInt(plugin.description.substring(plugin.description.indexOf(".")-1));
    }
  }
  return bt;
}




